<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_c95cbc316178c97697a403f" . "4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN" . "0X2NvZGUgZXE6c3RyOmNvZGU="), "_0877a0b48cf424a0de57a453ce95e3" . "0c" => base64_decode("aW50On" . "VzZXJf" . "aWQ="), "_ef2948c87ef38aab922" . "6e41189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3Rf" . "Y29kZSBlcTpzdHI6Y29kZQ=="), "_938704c4c0169c3804d4bd6aa9" . "941a76" => base64_decode("Q2FuJ3QgbG9hZCB" . "BQ0w6IG9iamVjdC" . "Bjb2RlIG5vdCBzc" . "GVjaWZpZWQ="), "_27de5a45db71bf24058769b61b3" . "975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG" . "5vdCBzcGVjaWZpZWQ="), "_a8b22fedb27a11e07f5bb9a7c73" . "608ea" => base64_decode("c3RyKDEwMCk6b2Jq" . "ZWN0X2NvZGU="), "_3cda3f34ada928e4" . "aa39d4629c5504aa" => base64_decode("aW50OnJpZ2h" . "0cw=="), "_b06968b9268deaf3b38" . "0bd0fe922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlc" . "l9pZD1pbnQ6dWlk"), "_dbbe14f567693a631f8a43b6" . "5af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFi" . "YXNlOiBvYmplY3QgY29kZSBub3Qgc3BlY2lm" . "aWVk"), "_84718d828d2acc3c366f96" . "b07e841f6a" => base64_decode("YWNsLnN" . "pbXBsZQ" . "=="), "_a7ed4d7408bb99b8" . "7a09d89d4212d5de" => base64_decode("c2ltcGxlX2Fjb" . "A=="), "_80fc2a45acd" . "0150df87d1fb" . "728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5E" . "IHVzZXJfaWQ9aW50OnVpZA=="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_84718d828d2acc3c36" . "6f96b07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_80fc2a45acd01" . "50df87d1fb7289" . "40a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_a7ed4d7408bb99b87a09d89d421" . "2d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_a8b22fedb27a11e07f5b" . "b9a7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_0877a0b48cf424a0de57a453" . "ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_3cda3f34ada928e4aa39d4629c5504" . "aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_b06968b9268deaf3b380" . "bd0fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_938704c4c0169" . "c3804d4bd6aa99" . "41a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_c95cbc316178c976" . "97a403f4d9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_27de5a45db71bf240" . "58769b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_dbbe14f567693a631f8a43b65af91" . "7ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_ef2948c8" . "7ef38aab9" . "226e41189" . "b29ca7"], $acl->GetObjectCode());
    }
}